<html>
<head>
<!--<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />-->
<meta name="description" content="Aulas de Introdução a Computação Científica">

<title>Aulas de Introdução a Computação Científica</title>

<!-- Bootstrap style: bootstrap -->
<link rel="stylesheet" href="adicionais/bootstrap.min.css">

<link rel="stylesheet" href="adicionais/prism.css">

<link href="./imagens/favicon.ico" rel="icon">

<script type="text/x-mathjax-config">
  MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
</script>
<script type="text/javascript" async
  src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_CHTML">
</script>

</head>

<body>

<!-- Bootstrap navigation bar -->
<div class="navbar navbar-default navbar-fixed-top">
  <div class="navbar-header">
    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-responsive-collapse">
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
    </button>
    <a href="http://www.estruturas.ufpr.br">
        <img style="position: absolute; top: 0; left: 0; border: 0;" src="imagens/estruturasUFPR.png" alt="Voltar para Estruturas.UFPR">
    </a>
    <div class="hidden-xs">
        <a class="navbar-brand" style="position: absolute; left: 360px;" href="index.html">Aulas de Introdução a Computação Científica</a>
    </div>  
  </div>
  <div class="navbar-collapse collapse navbar-responsive-collapse">
    <ul class="nav navbar-nav navbar-right">
      <li class="dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown">Conteúdos <b class="caret"></b></a>
        <ul class="dropdown-menu">
            <li><a href="#___sec0" style="font-size: 80%;">Programando equações</a></li>
            <li><a href="#___sec1" style="font-size: 80%;">Laços e listas</a></li>
            <li><a href="#___sec2" style="font-size: 80%;">Funções e ramificações</a></li>
            <li><a href="#___sec3" style="font-size: 80%;">Entrada do usuário e manipulação de erros</a></li>
            <li><a href="#___sec4" style="font-size: 80%;">Arranjos e gráficos de curvas</a></li>            
            <li><a href="#___sec6" style="font-size: 80%;">Dicionários e cadeias de caracteres</a></li>
            <li><a href="#___sec7" style="font-size: 80%;">Introdução a Classes</a></li>            
            <li><a href="#___sec9" style="font-size: 80%;">Programação orientada a objeto</a></li>
            <li><a href="#___sec10" style="font-size: 80%;">Números aleatórios e jogos simples</a></li>
            <li><a href="#___secA" style="font-size: 80%;">Sequências e relações de recorrência</a></li>
            <li><a href="#___secB" style="font-size: 80%;">Programação de equações diferenciais</a></li>
            <li><a href="#___secC" style="font-size: 80%;">Gráficos tridimensionais</a></li>
            <li><a href="#___secD" style="font-size: 80%;">Programação em paralelo</a></li>
            <li><a href="#___secE" style="font-size: 80%;">Interfaces gráficas de usuário (GUI)</a></li>
            <li><a href="#___secF" style="font-size: 80%;">Migrando Python para código compilado</a></li>

        </ul>
      </li>
    </ul>
  </div>
</div>
<!-- end of navigation bar -->

<!-- ------------------- conteúdo principal ---------------------- -->
<div class="container">

    <div class="container" style="text-align: center; position: relative; top: 60px;">
        <h1>Introdução a Computação Científica</h1>                
        <b>Prof. Marco André Argenta</b>
    </div>

    <div class="container" style="position: relative; top: 100px;">

        <h2 id="___sec0">Programando equações</h2>

        <blockquote>
            <em>Se você está em dúvida de como fazer isso, sente e faça!</em>
        </blockquote>
        
        <div class="well">
            <p>
                Os primeiros exemplos envolvem programas para resolver equações matemáticas.
                Vamos aprender como escrever e rodar um programa em Python, como trabalhar com as variáveis,
                como computar funções matemáticas como $e^x$ e $sen(x)$, e como usar o Python
                para cálculos interativos.
            </p>
        </div>
        
        <h3>Conteúdo do tópico:</h3>           
        
        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="formulas/formulas.html" target="_blank">Por que programar? Inicie aqui!</a></li>
            <li class="list-group-item">Programas deve ser precisos!</li>
            <li class="list-group-item">Variáveis são nomes de objetos.</li>
            <li class="list-group-item">Tipos de objetos <code>int</code>, 
                <code>float</code>, <code>str</code>.</li>
            <li class="list-group-item">Escolha nomes de variáveis próximos aos 
                        símbolos matemáticos do problema sendo resolvido</li>
            <li class="list-group-item">Operações aritméticas em Python: termo a termo
                        (+/-) da esquerda para a direita, potências antes *
                        e / - como na matemática! Use parênteses se ficar na dúvida</li>
            <li class="list-group-item">Cuidado com divisões por inteiros!</li>
            <li class="list-group-item">Use o <code>printf</code> para controlar melhor as saídas</li>
            <li class="list-group-item">Termos importantes: objeto, variáveis, algoritmos, 
                                declarações, atribuições, implementação, verificação, 
                                depuração.</li>
        </ul>

        <h2 id="___sec1">Laços e listas</h2>

        <blockquote>
            <em>Vai repetir a declaração? Laço nela...</em>
        </blockquote>

        <div class="well">
            <p>
                Como tarefas repetitivas em um programa podem ser automatizadas
                com o uso de laços. Também serão introduzidos os objetos listas 
                para o armazenamento e processamento de coleções de dados com
                ordem específica. Laços e listas junto com o tópico anterior, 
                consistem na base fundamental para o resto
                do curso.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="lacoslistas/lacoslistas.html" target="_blank">Precisa 
                                repetir uma declaração? Armazenar dados? Inicie aqui!</a></li>
            <li class="list-group-item">Laços <code>while</code> e laços <code>for</code>.</li>
            <li class="list-group-item">>Listas e tuplas.</li>
            <li class="list-group-item">>Precisa de mais informação técnica sobre esse assunto
                            em Python: veja <a href="http://docs.python.org/index.html" target="_blank">
                                <tt>docs.python.org</tt></a>.</li>
            <li class="list-group-item">Exemplo: o que eu posso encontrar no módulo <code>math</code>?<br>
                                Vá até o índice da <a href="https://docs.python.org/2/reference/index.html" target="_blank">
                                Python Library Reference</a>, clique <a href="https://docs.python.org/2/genindex.html" target="_blank">
                                    index</a> no canto superior direito.<br>
                                    Clique em <a href="https://docs.python.org/2/genindex-M.html" target="_blank">M</a><br>
                                Procure por <em>math (module)</em>, e clique.</li>
        </ul>

        <h2 id="___sec2">Funções e Ramificações</h2>

        <blockquote>
            <em>Se sim, faça isso, se não, faça aquilo.</em>
        </blockquote>

        <div class="well">
            <p>
                Introduzindo dois conceitos fundamentais e extremamente úteis
                na programação: funções definidas pelo programador e 
                ramificação do fluxo do programa, o último também conhecido
                como testes <code>if</code>.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="funcoesramificacoes/funcoesramificacoes.html" target="_blank">
                        Se sim, faça isso, se não, faça aquilo. Inicie aqui!</a></li>
            <li class="list-group-item">Testes <code>if</code>.</li>
            <li class="list-group-item">Funções definidas pelo usuário.</li>
            <li class="list-group-item">Argumentos de posição e argumentos palavras-chave.</li>
        </ul>

        <h2 id="___sec3">Entrada do usuário e manipulação de erros</h2>

        <blockquote>
            <em>Deixe para depois... faça agora genérico!</em>
        </blockquote>

        <div class="well">
            <p>
                Dados de entrada pode ser definidos diretamente no programa,
                ou seja, especificar explicitamente os valores de variáveis:
                <code>A = 0.1</code> ou <code>w = 1</code>, o que pode ser 
                adequado para pequenos programas ou programas específicos.
                No geral, é considerado uma boa prática deixar que o usuário 
                forneça os dados de entrada quando o programa está rodando,
                sendo desnecessário modificar o programa propriamente dito
                para um novo conjunto de dados.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="entradaerros/entradaerros.html" target="_blank">
                                Como programadores profissinais pegam suas
                                entradas de dados? Inicie aqui!</a></li>
            <li class="list-group-item">Entrada de dados por perguntas e respostas.</li>
            <li class="list-group-item">Entrada de dados por linha de comando.</li>
            <li class="list-group-item">Avaliando expressões de texto com o <code>eval</code>.</li>
            <li class="list-group-item">Executando textos em Python usando o <code>exec</code>.</li>
            <li class="list-group-item">>Manipulando exceções.</li>
            <li class="list-group-item">Levantando as exceções.</li>
            <li class="list-group-item">Lendo e escrevendo em arquivos.</li>
        </ul>

        <h2 id="___sec4">Arranjos e gráficos de curvas</h2>
        
        <blockquote>
            <em>São muitos os dados: use arranjos e grafique para melhor visualizar!</em>
        </blockquote>

        <div class="well">
            <p>
                Um objeto lista é útil para o armazenamento de dados, como uma
                sequência de objetos ou uma tabela de objetos. Um arranjo (no
                inglês array) é
                similar a uma lista, mas menos flexível e muito mais eficiente
                computacionalmente. Quando usa-se um computador para a execução
                de operações matemáticas usualmente termina-se com um monte de números
                e operações matemáticas associadas. Armazenar números em uma lista
                em tal contexto pode levar a programas lentos, enquanto com "arrays"
                pode-se ter um programa mais rápido. Isso se torna crucial quando
                aplicações avançadas demandam horas, dias, inclusive semanas
                para terminar de processar um programa. Qualquer idéia inteligente
                que reduza o tempo de execução é primordial.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    Arranjos e gráficos! Inicie aqui!</a></li>
            <li class="list-group-item">Computação com arranjos: aplica-se operações
            matemáticas à quaisquer elementos (sem laços).</li> 
            <li class="list-group-item">Ex.: <code>sin(x**4)*exp(-x**2)</code>, <code>x</code> 
                pode ser arranjo ou escalar<br />
                para o arranjo, o <code>i</code>-ésimo elemento se torna
                <code>sin(x[i]**4)*exp(-x[i]**2)</code>.</li>
            <li class="list-group-item">Vetorização: fazer com que cálculos matemáticos
            se tornem válidos para arranjos.</li>
            <li class="list-group-item">Expressões matemáticas puras não necessiram 
            vetorizações extras.</li>
            <li class="list-group-item">Equações matemáticas envolvendo testes
            <code>if</code> necessitam de vetorizações extras.</li>
            <li class="list-group-item">Graficando curvas: linhas retas são
            traçadas entre cada ponto de dados.</li>
            <li class="list-group-item">Animações: faça uma cópia de cada quadro
            do gráfico e gere uma sequência sobre eles para produzir um filme.</li>
        </ul>        

        <h2 id="___sec6">Dicionários e cadeias de caracteres</h2>
        
        <blockquote>
            <em>Salve seus dados.</em>
        </blockquote>

        <div class="well">
            <p>
                Arquivos são utilizados para armazenamento permanente de informações
                em um computador. De experiências anteriores com o computador você
                já utilizou alguma forma de salvar informações em um arquivo
                para posteriormente acessá-la novamente abrindo o arquivo.
                Como fazer o python escrever, ler e interpretar os dados
                novamente é o que vamos ver nessa seção.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="dicionariosstrings/dicionariosstrings.html" target="_blank">
                    Quer salvar os dados: Inicie aqui!</a></li>
            <li class="list-group-item">Aprender a como ler um arquivo.</li>
            <li class="list-group-item">Guardar dados em arquivos usando um novo tipo 
                de objeto: <i>dicionários</i></li>
            <li class="list-group-item">Interpretar o conteúdo de arquivos usando 
            a manipulação das cadeias de caracteres.</li>
        </ul>

        <h2 id="___sec7">Introdução a Classes</h2>
        
        <blockquote>
            <em>Dividir para conquistar.</em>
        </blockquote>

        <div class="well">
            <p>
                Uma classe empacota um conjunto de dados (variáveis) com um 
                conjunto de funções que operam sobre esses dados. O objetivo é
                alcançar um código mais modular através do agrupamento de dados
                e funções em unidades gerenciáveis (normalmente pequenas). A 
                maioria dos cálculos matemáticos podem ser programados facilmente
                sem o uso de classes, mas em vários problemas, classes tornam
                as soluções mais elegantes e/ou deixam o código mais fácil
                de ser estendido a um novo estágio. No mundo não matemático, existem
                conceitos e algoritmos a eles associados que ajudam a estruturar a solução
                de um problema. Classes podem ajudar no entendimento do problema
                e contribuir para simplificar a modelagem dos dados e as ações em 
                programas.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="classes/classes.html" target="_blank">
                    Definindo uma classe. Inicie aqui!</a></li>
            <li class="list-group-item">Usando uma classe.</li>
            <li class="list-group-item">Métodos especiais.</li>
            <li class="list-group-item">Com os métodos especiais podemos criar
                novos objetos matemáticos como vetores, polinomiais e 
                números complexos e escrever aritmética.</li>
            <li class="list-group-item">A chamada de um método especial é
                bem útil.</li>
            <li class="list-group-item">Funções com parâmetros devem ser 
                representadas por uma classe com os parâmetros
                como atributos e com um método de chamada especial para
                a avaliação da função.</li>
        </ul>
        

        <h2 id="___sec9">Programação orientada a objeto</h2>
        
        <blockquote>
            <em>O filho do pai do dono do cachorro ao lado do vizinho do amigo
                tem um peixe azul.</em>
        </blockquote>

        <div class="well">
            <p>
                Aqui vamos introduzir as idéias básicas da programação orientada
                a objeto. Diferentes pessoas relacionam diferentes significados
                ao termo programação orientada a objeto: algumas usam o termo
                para programação com objetos em geral, enquanto outras para
                programação com hierarquia de classes. Nós vamos com o segundo
                grupo, pois é um termo largamente aceito em ciência da computação.
                Os primeiros poderiam utilizar de forma mais correta o termo
                programação baseada em objetos. Como tudo em Python é um objeto,
                nós fazemos programação orientada a objeto o tempo todo.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="poo/poo.html" target="_blank">
                    Um novo conceito, hierarquia. Inicie aqui!</a></li>
            <li class="list-group-item">Uma subclasse herda tudo da super classe.</li>
            <li class="list-group-item">Quando usar uma subclasse ou super classe?</li>
            <li class="list-group-item">O fluxo do programa pula entre super e sub classes.</li>
            <li class="list-group-item">Leva tempo para dominar quando e como usar
                orientação a objetos.</li>
            <li class="list-group-item">Estude exemplos!</li>
        </ul>
        
        <h2 id="___sec10">Números aleatórios e jogos simples</h2>
        
        Em breve...
        
<!--        <blockquote>
            <em> quote ....</em>
        </blockquote>

        <div class="well">
            <p>
                introdução....
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item">topicos...</li>
        </ul>-->
        
        <h2 id="___secA">Sequências e relações de recorrência</h2>
        
        Em breve...
        
<!--        <blockquote>
            <em>With a computer it is then very easy to generate 
                the sequence by solving the difference equations</em>
        </blockquote>

        <div class="well">
            <p>                
                For some sequences it is not so easy to set up a general formula for the
                n-th term. Instead, it is easier to express a relation between two or more
                consecutive elements. One example where we can do both things is the
                sequence of odd numbers. This sequence can alternatively be generated
                by the formula $ x_{n+1} = x_n + 2 $. To start the sequence, we need 
                an initial condition where the value of the first element is specified:
                $ x_0 = 1 $
                Relations like this between consecutive elements in a sequence is called
                recurrence relations or difference equations. Solving a difference equation
                can be quite challenging in mathematics, but it is almost trivial to solve
                it on a computer.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    Sequências e suas relações: Inicie aqui!</a></li>
        </ul>-->

        <h2 id="___secB">Programação de equações diferenciais</h2>
        
        <blockquote>
            <em>Implemente uma vez, aplique em qualquer lugar.</em>
        </blockquote>

        <div class="well">
            <p>
                Vamos analisar equações diferenciais ordinárias (ODEs)
                de um ponto de vista
                mais abstrato que nos permitirá formular métodos numéricos e 
                criar aplicativos mais gerais aplicáveis à vários problemas 
                que envolvem equações diferenciais na matemática,
                física, biologia e finanças.
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="diferenciais/diferenciais.html" target="_blank">
                    Como resolver qualquer equação diferencial ordinária?
                Inicir aqui! (S/ LINK)</a></li>
            <li class="list-group-item">Exemplos de equações diferenciais ordinárias.</li>
            <li class="list-group-item">Aproximações da solução</li>
            <li class="list-group-item">O quanto é preciso?</li>
            <li class="list-group-item">Como resolver qualquer EDO.</li>
            
        </ul>
        
        <h2 id="___secC">Gráficos tridimensionais</h2>
        
        Em breve...
        
<!--        <blockquote>
            <em> quote ....</em>
        </blockquote>

        <div class="well">
            <p>
                introdução....
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    topicos...</a></li>
        </ul>-->

        <h2 id="___secD">Programação em paralelo</h2>
        
        Em breve...
        
<!--        <blockquote>
            <em> quote ....</em>
        </blockquote>

        <div class="well">
            <p>
                introdução....
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    topicos...</a></li>
        </ul>-->
        
        <h2 id="___secE">Interfaces gráficas de usuário (GUI)</h2>

        Em breve...

<!--        <blockquote>
            <em> quote ....</em>
        </blockquote>

        <div class="well">
            <p>
                introdução....
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    topicos...</a></li>
        </ul>-->

        <h2 id="___secF">Migrando Python para código compilado</h2>

        Em breve...

<!--        <blockquote>
            <em> quote ....</em>
        </blockquote>

        <div class="well">
            <p>
                introdução....
            </p>
        </div>

        <h3>Conteúdo do tópico:</h3>           

        <ul class="list-group" style="text-align: center;">
            <li class="list-group-item"><a href="arranjosgraficos/arranjosgraficos.html" target="_blank">
                    topicos...</a></li>
        </ul>-->

        <hr>

        <p id="def_footnote_1"><b>1:</b> Ver 
            <a href="http://www.estruturas.ufpr.br/disciplinas/pos-graduacao/introducao-a-computacao-cientifica-com-python/introducao-python/1-python/" target="_blank">
            Aulas de python básico
            </a> se você sentir dificuldade com o conteúdo destas aulas. Conteúdo traduzido e adaptado para a disciplina 
            do livro A Primer on Scientific Programming with Python, de Hans Petter Langtangen.
        </p>
        

    </div>

</div>  
<!-- final conteúdo principal -->

<!-- include javascript, jQuery *first* -->
<script src="adicionais/jquery.min.js"></script>
<script src="adicionais/bootstrap.min.js"></script>

<script src="adicionais/prism.js"></script>



</body>
</html>
